﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using MindFusion.Diagramming.Wpf;

namespace glued_nodes
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		public Window1()
		{
			InitializeComponent();

			create();
			create();

			diagram.NodeSelecting += diagram_NodeSelecting;
		}

		bool imSelecting = false;

		void diagram_NodeSelecting(object sender, NodeValidationEventArgs e)
		{
			if (imSelecting)
				return;

			if (e.Node.MasterGroup != null)
			{
				e.Cancel = true;

				imSelecting = true;
				diagram.Selection.Change(e.Node.MasterGroup.MainItem);
				imSelecting = false;
			}
		}

		void create()
		{
			var parent = diagram.Factory.CreateShapeNode(50, 50, 100, 150);
			parent.Transparent = true;
			parent.EnabledHandles = AdjustmentHandles.Move;
			parent.HandlesStyle = HandlesStyle.HatchFrame;

			var child1 = diagram.Factory.CreateShapeNode(50, 50, 100, 100);
			child1.HandlesStyle = HandlesStyle.Invisible;
			child1.Shape = Shapes.Rectangle;
			child1.Brush = Brushes.White;
			var child2 = diagram.Factory.CreateTableNode(50, 150, 100, 50);
			child2.CaptionHeight = 0;
			child2.Caption = "";
			child2.HandlesStyle = HandlesStyle.Invisible;

			child1.AttachTo(parent, MindFusion.Diagramming.Wpf.AttachToNode.TopLeft | MindFusion.Diagramming.Wpf.AttachToNode.BottomRight);
			child2.AttachTo(parent, MindFusion.Diagramming.Wpf.AttachToNode.TopLeft);
		}
	}
}
